# APRIORI_PYTHON_HEADER_START#################################################
#                                                          vi: set ts=8: sw=4:
# @(#) $Id: __init__.py,v 1.13 2003/10/11 09:42:39 th Exp $
#
# HtmlArea3 for Zope -- integrates InteractiveTools' htmlArea 3.0 alpha
#                       into Zope (see their --> license.txt);
# license: --> COPYING
# ----------------------------------------------------------------------------
# Copyright (C) 2003  APRIORI business solutions AG
#                     http://www.apriori.de
# ----------------------------------------------------------------------------
# This file is a part of the 'HtmlArea3 for Zope' product.
#
# HtmlArea3 for Zope is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# HtmlArea3 for Zope is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
# 
# $Log: __init__.py,v $
# Revision 1.13  2003/10/11 09:42:39  th
# no message
#
# Revision 1.12  2003/10/11 09:20:26  th
# ZPT support
#
# Revision 1.8  2003/10/02 11:39:28  th
# initial copylefted version
#
#
# APRIORI_PYTHON_HEADER_END###################################################
"""
HtmlArea Product

This product integrates HtmlArea 3 (alpha) into Zope.
"""
__doc__ = """HtmlArea3 for Zope"""
__version__ = '0.5.1'

# raise Exception(__file__)
import glob
from ImageFile import ImageFile

misc_ = { 'dialog.js':      ImageFile('dialog.js', globals()),
          'htmlarea.css':   ImageFile('htmlarea.css', globals()),
          'popup.css':      ImageFile('popup.css', globals()),
          'htmlarea.js':    ImageFile('htmlarea_zope.js', globals()),
          'reference.html': ImageFile('reference_zope.html', globals()),
          'about.html':     ImageFile('popups/about_zope.html', globals()),
         }

from os import path
_path=path.dirname(__file__)+'/'

_offset = len(_path)

_languages = []
_pp = _path 
for name in glob.glob(_pp+'*.js'):
    newid = name[_offset:]
    if newid in misc_.keys():
        continue
    if newid.startswith('htmlarea-lang-'):
        _languages.append(newid[14:-3]) # supported languages
    misc_[newid] = ImageFile(name[_offset:], globals())

_pp = _path + 'images/'
for name in glob.glob(_pp+'*.gif'):
    newid = name[_offset+7:]
    misc_[newid] = ImageFile(name[_offset:], globals())

_pp = _path + 'popups/'
misc_['about.html'] = ImageFile('popups/about_zope.html', globals())
for name in glob.glob(_pp+'*.html'):
    newid = name[_offset+7:]
    if newid in misc_.keys():
        continue
    misc_[newid] = ImageFile(name[_offset:], globals())

# for popup.js:
for name in glob.glob(_pp+'*.js'):
    newid = name[_offset+7:]
    if newid in misc_.keys():
        continue
    misc_[newid] = ImageFile(name[_offset:], globals())

import HtmlArea
HtmlArea.HtmlArea3_languages = _languages

# If you have more than one 'htmlArea for Zope' product in your Zope,
# only the first one found can be made 'public', i.e. its methods are 
# available to any Zope object without further afford; the others can be
# used via the appropriate HtmlAreaMixin class only.
#
# To explicitely choose this version, define an environment variable
# 'HTMLAREA4ZOPE_PUBLIC', containing the value used in the below call
# to _do_publish
def _do_publish(v):
    from os import getenv, putenv
    tmp=getenv('HTMLAREA4ZOPE_PUBLIC')
    if not tmp:
        putenv('HTMLAREA4ZOPE_PUBLIC', v)
        return 1
    return tmp.strip().lower() == v

if _do_publish('3.0alpha'):
    methods = {
        # just the transformation into an htmlArea:
        'htmlArea_editor':          HtmlArea.htmlArea_editor,
        # including the textarea, calling the former:
        'htmlArea':                 HtmlArea.htmlArea,
        # this is for the HTML head (Javascript code):
        'htmlArea_prefix':          HtmlArea.htmlArea_prefix,
        # make the buttons look like they should (HTML head):
        'htmlArea_style':           HtmlArea.htmlArea_style,
        # combine both (new in HtmlArea for Zope 0.5.1):
        'htmlArea_head':            HtmlArea.htmlArea_head,
        # transform all textareas without further configuration
        # (Javascript statement):
        'htmlArea_allStatement':    HtmlArea.htmlArea_allStatement,
        # the former enbedded in a script tag:
        'htmlArea_all':             HtmlArea.htmlArea_all,
        # interactive demo:
        'htmlArea_demo':            HtmlArea.htmlArea_demo,
        
        # normally used implicitely (by htmlArea_prefix):
        'htmlArea_defaultLanguage': HtmlArea.htmlArea_defaultLanguage,
        # used by demo:
        'htmlArea_productLanguages':HtmlArea.htmlArea_productLanguages,
        # version info:
        'htmlArea_version':         HtmlArea.htmlArea_version,
        # interactive demo utility methods:
        'htmlArea_selectToolbar':   HtmlArea.htmlArea_selectToolbar,
        'htmlArea_selectLanguage':  HtmlArea.htmlArea_selectLanguage,
        # a Zope Page Template, containing at least one macro ;-)
        'htmlArea_':                HtmlArea.htmlArea_,
    }
